Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/VectorExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/VectorExpressionTests.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/VectorExpressionTests.cs	(revision 15017)
@@ -0,0 +1,454 @@
+﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
+  using System.Collections.Generic;
+  using System.Linq;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  public abstract class VectorExpressionTests<T> : CommonTests<IReadOnlyList<T>> {
+
+    protected abstract IPushStack<T> LiteralStack { get; }
+    protected abstract IReadOnlyList<T> GetLiterals(int count);
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorButLast() {
+      var vector = GetValues(1)[0];
+      Stack.Push(vector);
+
+      var result = vector.Take(vector.Count - 1);
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".BUTLAST");
+      interpreter.Run(expression);
+
+      Assert.IsTrue(result.SequenceEqual(Stack.Top));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorConcat() {
+      var vectors = GetValues(2);
+      Stack.Push(vectors);
+
+      var result = vectors.SelectMany(x => x);
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".CONCAT");
+      interpreter.Run(expression);
+
+      Assert.IsTrue(result.SequenceEqual(Stack.Top));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorConj() {
+      var vectors = GetValues(1);
+      var literals = GetLiterals(1);
+
+      Stack.Push(vectors);
+      LiteralStack.Push(literals);
+
+      var result = new List<T>(vectors[0]);
+      result.AddRange(literals);
+
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".CONJ");
+      interpreter.Run(expression);
+
+      Assert.IsTrue(result.SequenceEqual(Stack.Top));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorContains() {
+      var vectors = Get2Different();
+      var literalContained = vectors[0].Last();
+      var literalNotContained = vectors[1].FirstOrDefault(x => !vectors[0].Contains(x));
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".CONTAINS");
+
+      Stack.Push(vectors[0], vectors[0]);
+      LiteralStack.Push(literalContained, literalNotContained);
+
+      interpreter.Run(expression);
+      interpreter.Run(expression);
+
+      Assert.IsTrue(interpreter.BooleanStack[0]);
+      Assert.IsFalse(interpreter.BooleanStack[1]);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorEmpty() {
+      var emptyVector = new List<T>();
+      var noneEmptyVector = GetValues(1)[0];
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".EMPTYVECTOR");
+
+      Stack.Push(emptyVector, noneEmptyVector);
+      interpreter.Run(expression);
+      interpreter.Run(expression);
+
+      Assert.IsTrue(interpreter.BooleanStack[0]);
+      Assert.IsFalse(interpreter.BooleanStack[1]);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorFirst() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".FIRST");
+
+      Stack.Push(emptyVector);
+      interpreter.Run(expression);
+      Assert.IsTrue(LiteralStack.IsEmpty);
+
+      Stack.Push(vector);
+      interpreter.Run(expression);
+      Assert.AreEqual(vector.First(), LiteralStack.Top);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorIndexOf() {
+      var vector = GetValues(1)[0].Distinct().ToList();
+      var emptyVector = new List<T>();
+      var literal = vector.Last();
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".INDEXOF");
+
+      Stack.Push(emptyVector);
+      LiteralStack.Push(literal);
+      interpreter.Run(expression);
+      Assert.IsTrue(LiteralStack == interpreter.IntegerStack ? LiteralStack.Count == 1 : LiteralStack.IsEmpty);
+
+      Stack.Push(vector);
+      LiteralStack.Push(literal);
+      interpreter.Run(expression);
+      Assert.AreEqual(vector.Count - 1, interpreter.IntegerStack.Top);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorIterate() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".ITERATE");
+      var bodyExpression = new ExecNoopExpression();
+
+      Stack.Push(emptyVector);
+      interpreter.Run(new PushProgram(new[] { expression, bodyExpression }));
+      Assert.IsTrue(LiteralStack.IsEmpty);
+      Assert.AreEqual(0, Stack.Top.Count);
+
+      Stack.Push(vector);
+      interpreter.Run(new PushProgram(new[] { bodyExpression, expression }));
+      Assert.AreEqual(vector.Count, LiteralStack.Count);
+      Assert.IsTrue(LiteralStack.Reverse().SequenceEqual(vector));
+    }
+
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorLast() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".LAST");
+
+      Stack.Push(emptyVector);
+      interpreter.Run(expression);
+      Assert.IsTrue(LiteralStack.IsEmpty);
+
+      Stack.Push(vector);
+      interpreter.Run(expression);
+      Assert.AreEqual(vector.Last(), LiteralStack.Top);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorLength() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".LENGTH");
+
+      Stack.Push(emptyVector);
+      interpreter.Run(expression);
+      Assert.AreEqual(0, interpreter.IntegerStack.Top);
+
+      Stack.Push(vector);
+      interpreter.Run(expression);
+      Assert.AreEqual(vector.Count, interpreter.IntegerStack.Top);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorNth() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var index = vector.Count / 2;
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".NTH");
+
+      Stack.Push(emptyVector);
+      interpreter.IntegerStack.Push(index);
+      interpreter.Run(expression);
+      Assert.IsTrue(LiteralStack == interpreter.IntegerStack ? LiteralStack.Count == 1 : LiteralStack.IsEmpty);
+
+      Stack.Push(vector);
+      interpreter.IntegerStack.Push(index);
+      interpreter.Run(expression);
+      Assert.AreEqual(vector[index], LiteralStack.Top);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorOccurrenceOf() {
+      var vector = GetValues(1)[0];
+      var literal = vector.Last();
+      var result = vector.Count(x => x.Equals(literal));
+      var emptyVector = new List<T>();
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".OCCURRENCEOF");
+
+      Stack.Push(emptyVector);
+      LiteralStack.Push(literal);
+      interpreter.Run(expression);
+      Assert.AreEqual(0, interpreter.IntegerStack.Top);
+
+      Stack.Push(vector);
+      LiteralStack.Push(literal);
+      interpreter.Run(expression);
+      Assert.AreEqual(result, interpreter.IntegerStack.Top);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorPushAll() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".PUSHALL");
+
+      Stack.Push(emptyVector);
+      interpreter.Run(expression);
+      Assert.IsTrue(LiteralStack.IsEmpty);
+
+      Stack.Push(vector);
+      interpreter.Run(expression);
+      Assert.IsTrue(LiteralStack.Reverse().SequenceEqual(vector));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorRemove() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var literal = vector.Last();
+      var result = vector.Where(x => !x.Equals(literal));
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".REMOVE");
+
+      Stack.Push(emptyVector);
+      LiteralStack.Push(literal);
+      interpreter.Run(expression);
+      Assert.AreEqual(0, Stack.Top.Count);
+
+      Stack.Push(vector);
+      LiteralStack.Push(literal);
+      interpreter.Run(expression);
+      Assert.IsTrue(Stack.Top.SequenceEqual(result));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorReplace() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var literal = vector.Last();
+      var literalTarget = vector.First();
+      var result = vector.Select(x => x.Equals(literal) ? literalTarget : x);
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".REPLACE");
+
+      Stack.Push(emptyVector);
+      LiteralStack.Push(literal, literalTarget);
+      interpreter.Run(expression);
+      Assert.AreEqual(0, Stack.Top.Count);
+
+      Stack.Push(vector);
+      LiteralStack.Push(literal, literalTarget);
+      interpreter.Run(expression);
+      Assert.IsTrue(Stack.Top.SequenceEqual(result));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorReplaceFirst() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var literal = vector.Last();
+      var literalTarget = vector.First(x => !x.Equals(literal));
+      var firstReplaced = false;
+      var result = vector.Select(x => {
+        if (!x.Equals(literal) || firstReplaced) return x;
+        firstReplaced = true;
+        return literalTarget;
+      }).ToArray();
+
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".REPLACEFIRST");
+
+      Stack.Push(emptyVector);
+      LiteralStack.Push(literal, literalTarget);
+      interpreter.Run(expression);
+      Assert.AreEqual(0, Stack.Top.Count);
+
+      Stack.Push(vector);
+      LiteralStack.Push(literal, literalTarget);
+      interpreter.Run(expression);
+      Assert.IsTrue(Stack.Top.SequenceEqual(result));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorRest() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var result = vector.Skip(1);
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".REST");
+
+      Stack.Push(emptyVector);
+      interpreter.Run(expression);
+      Assert.AreEqual(0, Stack.Top.Count);
+
+      Stack.Push(vector);
+      interpreter.Run(expression);
+      Assert.IsTrue(Stack.Top.SequenceEqual(result));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorReverse() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var result = new List<T>(vector);
+      result.Reverse();
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".REVERSE");
+
+      Stack.Push(emptyVector);
+      interpreter.Run(expression);
+      Assert.AreEqual(emptyVector, Stack.Top);
+
+      Stack.Push(vector);
+      interpreter.Run(expression);
+      Assert.IsTrue(Stack.Top.SequenceEqual(result));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorSet() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var index = vector.Count / 2;
+      var literal = vector.Last();
+      var result = vector.ToArray();
+      result[index] = literal;
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".SET");
+
+      Stack.Push(emptyVector);
+      LiteralStack.Push(literal);
+      interpreter.IntegerStack.Push(index);
+      interpreter.Run(expression);
+      Assert.AreEqual(emptyVector, Stack.Top);
+
+      Stack.Push(vector);
+      interpreter.IntegerStack.Push(index);
+      LiteralStack.Push(literal);
+      interpreter.Run(expression);
+      Assert.IsTrue(Stack.Top.SequenceEqual(result));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorSub() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var start = 0;
+      var end = vector.Count / 2;
+      var result = vector.Skip(start).Take(end).ToArray();
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".SUB");
+
+      Stack.Push(emptyVector);
+      interpreter.IntegerStack.Push(start, end);
+      interpreter.Run(expression);
+      Assert.AreEqual(emptyVector, Stack.Top);
+
+      Stack.Push(vector);
+      interpreter.IntegerStack.Push(start, end);
+      interpreter.Run(expression);
+      Assert.IsTrue(Stack.Top.SequenceEqual(result));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("VectorExpressionTest")]
+    public void TestVectorTake() {
+      var vector = GetValues(1)[0];
+      var emptyVector = new List<T>();
+      var count = vector.Count / 2;
+      var result = vector.Take(count).ToArray();
+      var expression = ExpressionTable.GetStatelessExpression(TypeName + ".TAKE");
+
+      Stack.Push(emptyVector);
+      interpreter.IntegerStack.Push(count);
+      interpreter.Run(expression);
+      Assert.AreEqual(emptyVector, Stack.Top);
+
+      Stack.Push(vector);
+      interpreter.IntegerStack.Push(count);
+      interpreter.Run(expression);
+      Assert.IsTrue(Stack.Top.SequenceEqual(result));
+
+      Stack.Push(vector);
+      interpreter.IntegerStack.Push(count * -1);
+      interpreter.Run(expression);
+      Assert.IsTrue(Stack.Top.SequenceEqual(result));
+
+      Stack.Push(vector);
+      interpreter.IntegerStack.Push(count + vector.Count);
+      interpreter.Run(expression);
+      Assert.IsTrue(Stack.Top.SequenceEqual(result));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Problem/IndividualMapperTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Problem/IndividualMapperTests.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Problem/IndividualMapperTests.cs	(revision 15017)
@@ -0,0 +1,78 @@
+﻿// ReSharper disable AccessToDisposedClosure
+namespace HeuristicLab.Tests.Problem {
+  using System;
+  using System.Diagnostics;
+  using System.Linq;
+
+  using HeuristicLab.Core;
+  using HeuristicLab.Encodings.IntegerVectorEncoding;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Problem;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+  using HeuristicLab.Random;
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class IndividualMapperTests {
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("Individual")]
+    public void TestRandomReset() {
+      var random = new MersenneTwister(1337);
+      var config = new PushConfiguration {
+        ErcOptions = new ErcOptions {
+          ErcProbability = 0.05,
+          IntegerErcOptions = new IntegerErcOptions(
+            new IntegerConstantErc(0),
+            new IntegerRangeErc(-1000, 100))
+        }
+      };
+
+      var vector = new IntegerVector(10000, random, 0, config.EnabledExpressions.Count);
+      var randomPool = new ObjectPool<IRandom>(() => new MersenneTwister());
+      var pool = new PushInterpreterPool(config);
+
+      var programs = Enumerable.Range(0, Environment.ProcessorCount)
+        .AsParallel()
+        .Select(i => vector.ToPushProgram(config, randomPool))
+        .ToArray();
+
+      var referenceProgram = vector.ToPushProgram(config, randomPool);
+      Assert.IsTrue(programs.All(p => p.Equals(referenceProgram)));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("Individual")]
+    public void TestPlushToProgram() {
+      var random = new MersenneTwister();
+      var config = new PushConfiguration {
+        ParenthesesCloseBiasLevel = 4
+      };
+
+      config.DisableStack(StackTypes.Name);
+      config.DisableStack(StackTypes.Float);
+      config.DisableStack(StackTypes.Code);
+      config.DisableStack(StackTypes.Boolean);
+      config.DisableStack(StackTypes.IntegerVector);
+      config.DisableStack(StackTypes.FloatVector);
+      config.DisableStack(StackTypes.StringVector);
+      config.DisableStack(StackTypes.BooleanVector);
+
+      var sw = new Stopwatch();
+      var vector = new IntegerVector(100, random, 0, config.EnabledExpressions.Count);
+
+      sw.Start();
+      var program = vector.ToPushProgram(config, random);
+      sw.Stop();
+
+      Console.WriteLine(@"Duration: {0}ms", sw.ElapsedMilliseconds);
+      Assert.AreEqual(vector.Length, program.TotalExpressionCount);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Simplifier/SimplifierTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Simplifier/SimplifierTests.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Simplifier/SimplifierTests.cs	(revision 15017)
@@ -0,0 +1,50 @@
+﻿namespace HeuristicLab.Tests.Simplifier {
+  using System;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Simplifier;
+  using HeuristicLab.Random;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class SimplifierTests {
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("Simplifier")]
+    public void SimplifySubProgramsTest() {
+      var program = PushParser.ParseProgram("( ( ( ( ( 1 ) ) ) ) )");
+      var result = PushParser.ParseProgram("( 1 )");
+      var simplerProgram = Simplifier.SimplifySubPrograms(program);
+
+      Console.WriteLine(simplerProgram);
+      Assert.AreEqual(result, simplerProgram);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("Simplifier")]
+    public void RemoveUnnecessaryExpressionsTest() {
+      var program = PushParser.ParseProgram("( 5 ( INTEGER.DUP FLOAT.+ FLOAT.- ) ( EXEC.DO ( EXEC.IF ) EXEC.Y ) INTEGER.+ )");
+      var result = PushParser.ParseProgram("( 5 INTEGER.DUP INTEGER.+ )");
+      var pool = new PushInterpreterPool();
+      var random = new MersenneTwister(1337);
+
+      Func<PushProgram, double> evaluator = p => {
+        using (var interpreter = pool.Create(random)) {
+          interpreter.Run(p);
+          return interpreter.IntegerStack.IsEmpty
+            ? double.MaxValue
+            : Math.Abs(interpreter.IntegerStack.Top - 10);
+        }
+      };
+
+      var simplerProgram = Simplifier.Simplify(program, pool.PushConfiguration, evaluator);
+
+      Console.WriteLine(simplerProgram);
+      Assert.AreEqual(result, simplerProgram);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs	(revision 15017)
@@ -3,15 +3,46 @@
 
 namespace HeuristicLab.Algorithms.PushGP.Cli {
+  using System.Collections.Generic;
+  using System.Linq;
+
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Constants;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
 
   class Program {
     static void Main(string[] args) {
-      if (args.Length == 0) return;
+      string code = null;
 
-      var code = args[0];
+      if (args.Length == 0) {
+        var lines = new List<string>();
+
+        Console.WriteLine(@"Program: ( must start with '(' and end with ')' )");
+
+        var bracesCount = 0;
+        var linesRead = 0;
+
+        while (bracesCount > 0 || lines.Count == 0 || linesRead == 0) {
+          var line = Console.ReadLine();
+          linesRead++;
+
+          if (string.IsNullOrWhiteSpace(line))
+            continue;
+
+          line = line.Trim();
+          lines.Add(line);
+
+          var openBraces = line.Count(c => c == PushEnvironment.ProgramStartSymbol);
+          var closeBraces = line.Count(c => c == PushEnvironment.ProgramEndSymbol);
+          bracesCount += openBraces - closeBraces;
+        }
+
+        code = string.Join(" ", lines);
+      } else {
+        code = args[0];
+      }
+
       EvaluateStepwise(code).Wait();
 
-      Console.ReadKey();
+      Console.WriteLine(@"Press any key to terminate...");
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Push.Cli.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Push.Cli.csproj	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Push.Cli.csproj	(revision 15017)
@@ -50,4 +50,5 @@
     <Reference Include="System" />
     <Reference Include="System.Core" />
+    <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
